const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class CardsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const cards = await db.cards.create(
      {
        id: data.id || undefined,

        type: data.type || null,
        last4: data.last4 || null,
        limit: data.limit || null,
        status: data.status || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await cards.setEmployee(data.employee || null, {
      transaction,
    });

    await cards.setOrganizations(data.organizations || null, {
      transaction,
    });

    return cards;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const cardsData = data.map((item, index) => ({
      id: item.id || undefined,

      type: item.type || null,
      last4: item.last4 || null,
      limit: item.limit || null,
      status: item.status || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const cards = await db.cards.bulkCreate(cardsData, { transaction });

    // For each item created, replace relation files

    return cards;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const cards = await db.cards.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.type !== undefined) updatePayload.type = data.type;

    if (data.last4 !== undefined) updatePayload.last4 = data.last4;

    if (data.limit !== undefined) updatePayload.limit = data.limit;

    if (data.status !== undefined) updatePayload.status = data.status;

    updatePayload.updatedById = currentUser.id;

    await cards.update(updatePayload, { transaction });

    if (data.employee !== undefined) {
      await cards.setEmployee(
        data.employee,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await cards.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return cards;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const cards = await db.cards.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of cards) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of cards) {
        await record.destroy({ transaction });
      }
    });

    return cards;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const cards = await db.cards.findByPk(id, options);

    await cards.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await cards.destroy({
      transaction,
    });

    return cards;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const cards = await db.cards.findOne({ where }, { transaction });

    if (!cards) {
      return cards;
    }

    const output = cards.get({ plain: true });

    output.employee = await cards.getEmployee({
      transaction,
    });

    output.organizations = await cards.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.employees,
        as: 'employee',

        where: filter.employee
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.employee
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  user: {
                    [Op.or]: filter.employee
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.last4) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('cards', 'last4', filter.last4),
        };
      }

      if (filter.limitRange) {
        const [start, end] = filter.limitRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            limit: {
              ...where.limit,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            limit: {
              ...where.limit,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.type) {
        where = {
          ...where,
          type: filter.type,
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.cards.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('cards', 'last4', query),
        ],
      };
    }

    const records = await db.cards.findAll({
      attributes: ['id', 'last4'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['last4', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.last4,
    }));
  }
};
